/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : config.c, config functions                                  :
   : (c) 2004 Christian Jurk                                     :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */
   
#ifndef _HAVE_CONFIG
#define _HAVE_CONFIG

#include <stdio.h>
#include <stdlib.h>

#define configfile "conf/modserv.msc"

typedef struct mconfig_t {
  char item[60];
  char val[250];
  unsigned int len;
  struct mconfig_t *next;
} mconfig;

void mconfig_add(char *a, char *v);
void mconfig_del(memstr *a);
char *mconfig_get(char *item, char *def);
void delchar(char *a, char b);
unsigned int mconfig_read();

#endif /* _HAVE_CONFIG */
