/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : pgsql.h, postgresql database functions                      :
   : (c) 2004 GamerIRC developement team                         :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#ifndef _HAVE_PGSQL
#define _HAVE_PGSQL

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <time.h>
/* path to libpq */
#include <libpq-fe.h>

unsigned int pg_connect();
PGresult *pg_query(char *str, ...);
void pg_close(PGconn *c);
int pg_num_rows(PGresult *res);

PGconn *pgc;
long pg_querys;
time_t pg_startup;

#endif /* _HAVE_PGSQL */
