/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : servers.h, server database functions.                       :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */
   
#ifndef _HAVE_SERVERS
#define _HAVE_SERVERS

#include <stdio.h>
#include <stdlib.h>

typedef struct servers_t {
  char name[60];
  char snum[10];
  char flags[10];
  char hub[60];
  time_t starttime;
  time_t bursttime;
  struct servers_t *next;
} servers;

void addserver(char *name, char *snum, time_t sts, time_t bts, char *flags, char *hub);
void delserver(char *name);
unsigned int servercount();

servers *serv_list;

#endif /* _HAVE_SERVERS */
