/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : strfunc.h, string functions                                 :
   : (c) 2004 Christian Jurk                                     :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#ifndef _HAVE_STRFUNC
#define _HAVE_STRFUNC

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdarg.h>
#include <time.h>

void strtoupper(char *a);
void strtolower(char *a);
char *inttostr(int i, char *res);
unsigned int chrstr(unsigned int c, char *s);
void mailsend(char *target, char *subject, char *str, ...);
void dropcc(char *c, unsigned int i);
void resetchar(char *c);
unsigned int printhex(char *str);
void appchar(char *c, char a);
char *cctime(time_t a);
char *duration(long b);
void durationcp(long b, char *res);
unsigned long duration2long(char *d);
char *gettok(char *str, char *sep, int cs);
int strmatch(char *patrn, char *strng);
void strsort(char *str);
void strsortn(char *str);
void strcp(char *target, char *src);
void getmd5(char *src, char *tg);
int is_null(char *ptr, int expr);

#endif /* _HAVE_STRFUNC */
