/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : listmodules.c                                               :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "dynhdl.h"

#define command_module "core"
#define command_name   "listmodules"
#define command_desc   1021
#define command_oper   1
#define command_type   1
#define command_auth   1

void core_cmd_listmodules(char *arg, char *unum, char *target) {
  mhl *b; unsigned c=0;
  strarray(arg);
  m_notice(unum,target,getlang(1022,gu(unum,1)));
  m_notice(unum,target,"---");
  for(b=mod_list;b!=NULL;b=b->next) {
    m_notice(unum,target,getlang(1023,gu(unum,1)),(b->next==NULL) ? "`" : "|",b->name->str,b->desc->str,ctime(&b->loadtime));
    c++;
  }
  m_notice(unum,target,"---");
  m_notice(unum,target,"%d %s listed.",c,((c>1)&&(c!=0)) ? "modules" : "module");
}

void load_core_cmd_listmodules(void) {
  chl_add(command_module,command_name,core_cmd_listmodules,command_oper,command_type,command_auth,command_desc);
}
