/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : listtasks.c                                                 :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "dynhdl.h"
#include "schedule.h"

#define command_module "core"
#define command_name   "listtasks"
#define command_desc   1024
#define command_oper   1
#define command_type   1
#define command_auth   1

void core_cmd_listtasks(char *arg, char *unum, char *target) {
  schedule *c; int i;
  m_notice(unum,target,getlang(1025,gu(unum,1)));
  m_notice(unum,target,"---");
  for(c=sched_list,i=0;c!=NULL;c=c->next,i++) {
    m_notice(unum,target,getlang(1026,gu(unum,1)),c->taskid,c->module,(c->desc) ? c->desc : getlang(1027,gu(unum,1)),(c->type==TASK_ONCE) ? getlang(1028,gu(unum,1)) : getlang(1029,gu(unum,1)));
    m_notice(unum,target,getlang(1030,gu(unum,1)),cctime((time_t)c->lastact),c->runs,(c->runs==1) ? "" : "s",c->interval);
  }
  m_notice(unum,target,"---");
  m_notice(unum,target,getlang(1031,gu(unum,1)),i);
}

void load_core_cmd_listtasks(void) {
  chl_add(command_module,command_name,core_cmd_listtasks,command_oper,command_type,command_auth,command_desc);
}
