/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : loadcmd.c                                                   :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "dynhdl.h"

#define command_module "core"
#define command_name   "loadcmd"
#define command_desc   1032
#define command_oper   1
#define command_type   1
#define command_auth   1

char *mynum;

void core_cmd_loadcmd(char *arg, char *unum, char *target) {
  chl *a; char tmp[20]; int state;
  strarray(arg);
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(1033,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(1034,gu(unum,1)));
    m_notice(unum,target,getlang(1035,gu(unum,1)));
    return;
  } else if (cargc<2) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  inttostr(command_type,tmp);
  state = cmdstate(cargs[1],cargs[0]);
  if (state == 1) {
    m_notice(unum,target,getlang(1092,gu(unum,1)),cargs[1]);
    return;
  } else if (state == 2) {
    m_notice(unum,target,getlang(1093,gu(unum,1)),cargs[1]);
    return;
  }
  if ((loadcommand(cargs[0],"0",tmp,cargs[1]))) {
    m_notice(unum,target,getlang(1036,gu(unum,1)),cargs[1]);
    return;
  } else {
    m_notice(unum,target,getlang(1037,gu(unum,1)),cargs[1]);
    return;
  }
}

void load_core_cmd_loadcmd(void) {
  chl_add(command_module,command_name,core_cmd_loadcmd,command_oper,command_type,command_auth,command_desc);
}
