/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : raw.c                                                       :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "dynhdl.h"
#include "account.h"

#define command_module "core"
#define command_name   "raw"
#define command_desc   1094
#define command_oper   1
#define command_type   1
#define command_auth   1

void core_cmd_raw(char *arg, char *unum, char *target) {
  int i; char cmdstr[520];
  strarray(arg);
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(1095,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(1096,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  resetchar(cmdstr);
  for(i=0;i<cargc;i++) {
    strcat(cmdstr,cargs[i]);
    if ((i+1)<cargc) {
      strcat(cmdstr," ");
    }
  }
  cmdstr[strlen(cmdstr)]=0x00;
  /* check for suitable access */
  if (getuclev(getauth(unum))<3) {
    m_notice(unum,target,getlang(8202,gu(unum,1)));
    return;
  }
  send2up(cmdstr);
  m_notice(unum,target,getlang(1097,gu(unum,1)),(int)strlen(cmdstr));
}

void load_core_cmd_raw(void) {
  chl_add(command_module,command_name,core_cmd_raw,command_oper,command_type,command_auth,command_desc);
}
