/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : showcommands.c                                                 :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "dynhdl.h"

#define command_module "core"
#define command_name   "showcommands"
#define command_desc   8207
#define command_oper   0
#define command_type   1
#define command_auth   0

void core_cmd_showcommands(char *arg, char *unum, char *target) {
  chl *a;
  m_notice(unum,target,getlang(8208,gu(unum,1)));
  m_notice(unum,target,"---");
  for(a=cmd_list;a!=NULL;a=a->next) {
    if ((!strcmp(a->module,command_module)) && a->active) {
      if (a->oper && !isoper(unum)) continue;
      m_notice(unum,target,"\02%s\02 %s %s",a->command,getlang(a->desc,gu(unum,1)),(a->oper) ? "(oper)" : "");
    }
  }
  m_notice(unum,target,"---");
  m_notice(unum,target,getlang(8209,gu(unum,1)));
}

void load_core_cmd_showcommands(void) {
  chl_add(command_module,command_name,core_cmd_showcommands,command_oper,command_type,command_auth,command_desc);
}
