/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : sqlexec.c                                                       :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"

#define command_module "core"
#define command_name   "sqlexec"
#define command_desc   1098
#define command_oper   1
#define command_type   1
#define command_auth   1

void core_cmd_sqlexec(char *arg, char *unum, char *target) {
  unsigned c=0; char myquery[1024]; PGresult *res;
  strarray(arg);
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(1099,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(1100,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  resetchar(myquery);
  for(c=0;c<=cargc;c++) {
    strcat(myquery,cargs[c]);
    if ((c+1)<cargc) strcat(myquery," ");
  }
  res=pg_query(myquery);
  m_notice(unum,target,getlang(1101,gu(unum,1)),(int)pg_num_rows(res));
  PQclear(res);
  return;
}

void load_core_cmd_sqlexec(void) {
  chl_add(command_module,command_name,core_cmd_sqlexec,command_oper,command_type,command_auth,command_desc);
}
