/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : suspendcmd.c                                                :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "dynhdl.h"

#define command_module "core"
#define command_name   "suspendcmd"
#define command_desc   1068
#define command_oper   1
#define command_type   1
#define command_auth   1

void core_cmd_suspendcmd(char *arg, char *unum, char *target) {
  chl *a;
  strarray(arg);
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(1069,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(1070,gu(unum,1)));
    m_notice(unum,target,getlang(1071,gu(unum,1)));
    return;
  } else if (cargc<2) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  for(a=cmd_list;a!=NULL;a=a->next) {
    if (!strcasecmp(a->command,cargs[1]) && !strcasecmp(a->module,cargs[0])) {
      if (!a->active) {
        m_notice(unum,target,getlang(1072,gu(unum,1)),a->command);
        return;
      } else {
        a->active=0;
        m_notice(unum,target,getlang(1073,gu(unum,1)),a->command);
        return;
      }
    }
  }
}

void load_core_cmd_suspendcmd(void) {
  chl_add(command_module,command_name,core_cmd_suspendcmd,command_oper,command_type,command_auth,command_desc);
}
