/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : unloadmodule.c                                              :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "dynhdl.h"

#define command_module "core"
#define command_name   "unloadmodule"
#define command_desc   1079
#define command_oper   1
#define command_type   1
#define command_auth   1

void core_cmd_unloadmodule(char *arg, char *unum, char *target) {
  mhl *a;
  strarray(arg);
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(1080,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(1081,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  for(a=mod_list;a!=NULL;a=a->next) {
    if (!strcasecmp(a->name->str,cargs[0])) {
      unloadmod(a->name->str);
      m_notice(unum,target,getlang(1082,gu(unum,1)),cargs[0]);
      return;
    }
  }
  m_notice(unum,target,getlang(1083,gu(unum,1)),cargs[0]);
}

void load_core_cmd_unloadmodule(void) {
  chl_add(command_module,command_name,core_cmd_unloadmodule,command_oper,command_type,command_auth,command_desc);
}
