/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : unsuspendcmd.c                                                   :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "dynhdl.h"

#define command_module "core"
#define command_name   "unsuspendcmd"
#define command_desc   1084
#define command_oper   1
#define command_type   1
#define command_auth   1

char *mynum;

void core_cmd_unsuspendcmd(char *arg, char *unum, char *target) {
  chl *a; char tmp[20];
  strarray(arg);
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(1085,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(1086,gu(unum,1)));
    m_notice(unum,target,getlang(1087,gu(unum,1)));
    return;
  } else if (cargc<2) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  for(a=cmd_list;a!=NULL;a=a->next) {
    if (!a->command || a->command==NULL) continue;
    if (!a->module || a->module==NULL) continue;
    if (!strcasecmp(a->command,cargs[1]) && !strcasecmp(a->module,cargs[0])) {
      if (a->active) {
        m_notice(unum,target,getlang(1088,gu(unum,1)),a->command);
        return;
      } else {
        a->active=1;
        a->oper=atoi(cargs[2]);
        m_notice(unum,target,getlang(1089,gu(unum,1)),a->command,(a->oper) ? getlang(8210,gu(unum,1)) : getlang(1018,gu(unum,1)));
        return;
      }
    }
  }
  inttostr(command_type,tmp);
  if ((loadcommand(cargs[0],cargs[2],tmp,cargs[1]))) {
    m_notice(unum,target,getlang(1090,gu(unum,1)),cargs[1]);
    return;
  } else {
    m_notice(unum,target,getlang(1091,gu(unum,1)),cargs[1]);
    return;
  }
}

void load_core_cmd_unsuspendcmd(void) {
  chl_add(command_module,command_name,core_cmd_unsuspendcmd,command_oper,command_type,command_auth,command_desc);
}
