/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : banlist.c                                                   :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "channels.h"

#define command_module "cservice"
#define command_name   "banlist"
#define command_desc   2049
#define command_oper   0
#define command_type   1
#define command_auth   1

void cservice_cmd_banlist(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; chans *a; int b,i,cid; time_t expstamp; char leftt[60];
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2050,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2051,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  a=cptr(cargs[0]);
  if (!findchannel(cargs[0]) || a==NULL) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  if (!hascl(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2042,gu(unum,1)),cargs[0]);
    return;
  }
  if (!cl_master(cargs[0],unum) && !cl_owner(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2043,gu(unum,1)));
    return;
  }
  cid=getcid(a->name);
  res=pg_query("SELECT hostmask,expirets,banat,banby,breason FROM bans WHERE cid=%d;",cid);
  if (PQntuples(res)<1) {
    m_notice(unum,target,getlang(2052,gu(unum,1)),a->name);
    PQclear(res);
    return;
  }
  b=PQntuples(res);
  m_notice(unum,target,getlang(2053,gu(unum,1)),a->name);
  m_notice(unum,target,"---");
  for(i=0;i<b;i++) {
    resetchar(leftt);
    expstamp=(time_t)atol(PQgetvalue(res,i,1));
    durationcp((long)expstamp-time(NULL),leftt);
    m_notice(unum,target,getlang(2054,gu(unum,1)),PQgetvalue(res,i,0),PQgetvalue(res,i,3),cctime((time_t)atol(PQgetvalue(res,i,2))),PQgetvalue(res,i,2));
    m_notice(unum,target,getlang(2055,gu(unum,1)),cctime((time_t)expstamp),leftt,PQgetvalue(res,i,4));
  }
  m_notice(unum,target,"---");
  m_notice(unum,target,getlang(2056,gu(unum,1)),b,(b>1) ? "s" : "");
  PQclear(res);
}

void load_cservice_cmd_banlist(void) {
  chl_add(command_module,command_name,cservice_cmd_banlist,command_oper,command_type,command_auth,command_desc);
}
