/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : chanlev.c, Channel access level management.                 :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "channels.h"
#include "clients.h"

#define command_module "cservice"
#define command_name   "chanlev"
#define command_desc   2082
#define command_oper   0
#define command_type   1
#define command_auth   1

void cservice_cmd_chanlev(char *arg, char *unum, char *target) {
  strarray(arg); char *a,*b,*h; chans *c; PGresult *res,*res2; float avg; unsigned long tmpc,i,j,e[10];
  char acc[40],tmp[40],tmp2[40]; int cid;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2083,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2084,gu(unum,1)));
    m_notice(unum,target,getlang(2085,gu(unum,1)));
    m_notice(unum,target,getlang(2086,gu(unum,1)));
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2087,gu(unum,1)));
    m_notice(unum,target,getlang(2088,gu(unum,1)));
    m_notice(unum,target,getlang(2089,gu(unum,1)));
    m_notice(unum,target,getlang(2090,gu(unum,1)));
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2091,gu(unum,1)));
    m_notice(unum,target,getlang(2092,gu(unum,1)));
    m_notice(unum,target,getlang(2093,gu(unum,1)));
    m_notice(unum,target,getlang(2094,gu(unum,1)));
    m_notice(unum,target,getlang(2095,gu(unum,1)));
    m_notice(unum,target,getlang(2096,gu(unum,1)));
    m_notice(unum,target,getlang(2097,gu(unum,1)));
    m_notice(unum,target,getlang(2098,gu(unum,1)));
    m_notice(unum,target,getlang(2099,gu(unum,1)));
    m_notice(unum,target,getlang(2100,gu(unum,1)));
    m_notice(unum,target,getlang(2101,gu(unum,1)));
    m_notice(unum,target,getlang(2102,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!hascl(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2042,gu(unum,1)),cargs[0]);
    return;
  }
  cid=getcid(cargs[0]);
  if (cid<0) {
    slog("Warning: cid < 0!");
  } 
  if (cargc==1) {
    // display channel access list
    c=cptr(cargs[0]);
    if (c==NULL || !findchannel(cargs[0])) {
      m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
      return;
    }
    m_notice(unum,target,getlang(2103,gu(unum,1)),c->name);
    m_notice(unum,target,getlang(2104,gu(unum,1)));
    m_notice(unum,target,getlang(2105,gu(unum,1)),cctime((time_t)c->created));
    //strsort(c->modes);
    if (c->modes && c->modes!=NULL && strlen(c->modes)>0) {
      if (chrstr('l',c->modes)) {
        m_notice(unum,target,getlang(2106,gu(unum,1)),(c->modes[0]!='+') ? "+" : "",c->modes,(chrstr('k',c->modes) && c->key!=NULL) ? c->key : "",c->limit);

      } else {
        m_notice(unum,target,getlang(2107,gu(unum,1)),(c->modes[0]!='+') ? "+" : "",c->modes,(chrstr('k',c->modes) && c->key!=NULL) ? c->key : "");      
      }
    } else if (strlen(c->modes)<1) {
      m_notice(unum,target,getlang(2108,gu(unum,1)));
    }
    strtolower(cargs[0]);
    res=pg_query("SELECT suspended,joincount,regtime FROM channels WHERE lower(channel)='%s';",cargs[0]);
    if (pg_num_rows(res)<1) {
      m_notice(unum,target,getlang(2109,gu(unum,1)));
      PQclear(res);
      return;
    }
    b=PQgetvalue(res,0,0);
    m_notice(unum,target,getlang(2110,gu(unum,1)),(b[0]=='f') ? getlang(8205,gu(unum,1)) : getlang(8204,gu(unum,1)));
    if (b[0]!='f') {
      strtolower(cargs[0]);
      res2=pg_query("SELECT reason,suspendtime,suspendby,expire FROM csuspends WHERE lower(channel)='%s';",cargs[0]);
      if (pg_num_rows(res2)<1) {
        m_notice(unum,target,getlang(2111,gu(unum,1)));
      } else {
        m_notice(unum,target,getlang(2112,gu(unum,1)),PQgetvalue(res2,0,0));
        m_notice(unum,target,getlang(2113,gu(unum,1)),cctime((time_t)atol(PQgetvalue(res2,0,1))));
        m_notice(unum,target,getlang(2114,gu(unum,1)),PQgetvalue(res2,0,2));
        m_notice(unum,target,getlang(2115,gu(unum,1)),cctime((time_t)atol(PQgetvalue(res2,0,1))),duration((long)(time(NULL)-atol(PQgetvalue(res2,0,1)))));
      }
      PQclear(res2);
    }
    tmpc=(time(NULL)-atol(PQgetvalue(res,0,1)))/86400; /* calculate day-count */
    avg=atof(PQgetvalue(res,0,1))/tmpc; /* calculate join-average per day */
    m_notice(unum,target,getlang(2116,gu(unum,1)),atol(PQgetvalue(res,0,1)),avg);
    m_notice(unum,target,getlang(2117,gu(unum,1)),cctime((time_t)atol(PQgetvalue(res,0,2))));
    PQclear(res);
    m_notice(unum,target,getlang(2118,gu(unum,1)));
    /* flag listing */
    res=pg_query("SELECT account,flags FROM chanlevs WHERE cid=%d;",cid);
    if (pg_num_rows(res)<1) {
      m_notice(unum,target,getlang(2119,gu(unum,1)));
    } else {
      for(j=0;j<=10;j++) { e[j]=0; }
      for(i=0;i<pg_num_rows(res);i++) {
        b=PQgetvalue(res,i,1);
        if ((i+1)>=pg_num_rows(res)) {
          m_notice(unum,target,"`- \02%s (\02%s%s\02)\02",PQgetvalue(res,i,0),(b[0]!='+') ? "+" : "",b);
        } else {
          m_notice(unum,target,"|- \02%s (\02%s%s\02)\02",PQgetvalue(res,i,0),(b[0]!='+') ? "+" : "",b);
        }
        for(j=0;j<strlen(b);j++) {
          if (b[j]=='a') { e[0]++; continue; }
          if (b[j]=='b') { e[1]++; continue; }
          if (b[j]=='g') { e[2]++; continue; }
          if (b[j]=='i') { e[3]++; continue; }
          if (b[j]=='m') { e[4]++; continue; }
          if (b[j]=='n') { e[5]++; continue; }
          if (b[j]=='o') { e[6]++; continue; }
          if (b[j]=='q') { e[7]++; continue; }
          if (b[j]=='t') { e[8]++; continue; }
          if (b[j]=='v') { e[9]++; continue; }
          if (b[j]=='w') { e[10]++; continue; }
        }
      }
      j=0;
      m_notice(unum,target,getlang(2120,gu(unum,1)));
      m_notice(unum,target,"\02%ld\02 user%s, (\02%ld\02a, \02%ld\02b, \02%ld\02g, \02%ld\02i, \02%ld\02m, \02%ld\02n, \02%ld\02o, \02%ld\02q, \02%ld\02t, \02%ld\02v, \02%ld\02w)",i,(i>1) ? "s" : "",e[0],e[1],e[2],e[3],e[4],e[5],e[6],e[7],e[8],e[9],e[10]);
    }
    PQclear(res);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2121,gu(unum,1)));
    return;
  } else if (cargc==2) {
    // display flags of a user
    if (cargs[1][0]=='#') {
      sprintf(acc,"%s",cargs[1]+1);
      strtolower(acc);
      res=pg_query("SELECT account,created,lastauth FROM users WHERE lower(account)='%s';",acc);
      if (pg_num_rows(res)<1) {
        m_notice(unum,target,getlang(8211,gu(unum,1)),acc);
        PQclear(res);
        return;
      }
      strcpy(acc,PQgetvalue(res,0,0));
      PQclear(res);
    } else {
      if (nick2num(cargs[1])==NULL) {
        m_notice(unum,target,getlang(8214,gu(unum,1)),cargs[1]);
        return;
      }
      if (getauth(nick2num(cargs[1]))==NULL) {
        m_notice(unum,target,getlang(8215,gu(unum,1)),cargs[1]);
        return;
      }
      strcpy(acc,getauth(nick2num(cargs[1])));
    }
    h=getchanlev(cargs[0],acc);
    if (h==NULL) {
      m_notice(unum,target,getlang(2122,gu(unum,1)),acc);
      return;
    }
    m_notice(unum,target,getlang(2123,gu(unum,1)),acc,(h[0]!='+') ? "+" : "",h);
    free(h);
    return;
  } else if (cargc==3) {
    // set flags of a user
    if (!cl_master(cargs[0],unum) && !cl_owner(cargs[0],unum) && !isoper(unum)) {
      m_notice(unum,target,getlang(2124,gu(unum,1)));
      return;
    }
    if (cargs[1][0]=='#') {
      sprintf(acc,"%s",cargs[1]+1);
      strtolower(acc);
      res=pg_query("SELECT account,created,lastauth FROM users WHERE lower(account)='%s';",acc);
      if (pg_num_rows(res)<1) {
        m_notice(unum,target,getlang(8211,gu(unum,1)),acc);
        PQclear(res);
        return;

      }
      strcpy(acc,PQgetvalue(res,0,0));
      PQclear(res);
    } else {
      if (nick2num(cargs[1])==NULL) {
        m_notice(unum,target,getlang(8214,gu(unum,1)),cargs[1]);
        return;
      }    
      if (getauth(nick2num(cargs[1]))==NULL) {
        m_notice(unum,target,getlang(8215,gu(unum,1)),cargs[1]);
        return;
      }
      strcpy(acc,getauth(nick2num(cargs[1])));
    }
    j=0; e[0]=0; e[1]=0; e[2]=0; e[3]=0;
    h=getchanlev(cargs[0],acc);
    if (h==NULL) {
      strcpy(tmp,"+");
      e[3]=1;
    } else {
      strcpy(tmp,h);
    }
    for(i=0;i<strlen(cargs[2]);i++) {
      if (cargs[2][i]=='+') { j=1; continue; }
      if (cargs[2][i]=='-') { j=2; continue; }
      if (!isvalidcl(cargs[2][i])) {
        m_notice(unum,target,getlang(2079,gu(unum,1)),cargs[2][i]);
        continue;
      }
      if (j==1) {
        // adding flag
        if ((cargs[2][i]=='m' || cargs[2][i]=='n') && !cl_owner(cargs[0],unum) && !isoper(unum)) {
          m_notice(unum,target,getlang(2125,gu(unum,1)),cargs[2][i]);
          continue;
        }
        if (!chrstr(cargs[2][i],tmp)) {
          appchar(tmp,cargs[2][i]);
          e[0]++;
        }
      } else if (j==2) {
        // removing flag
        if ((cargs[2][i]=='m' || cargs[2][i]=='n') && !cl_owner(cargs[0],unum) && !isoper(unum)) {
          m_notice(unum,target,getlang(2126,gu(unum,1)),cargs[2][i]);
          continue;
        }
        if (chrstr(cargs[2][i],tmp)) {
          delchar(tmp,cargs[2][i]);
          e[1]++;
        }
      } else {
        m_notice(unum,target,getlang(2127,gu(unum,1)),cargs[2][i]);
        continue;
      }
    }
    if (!strcmp(tmp,"+")) {
      // no flags left, remove the user from the channel
      strtolower(acc);
      pg_query("DELETE FROM chanlevs WHERE lower(account)='%s' AND cid=%d;",acc,cid);
      res=pg_query("SELECT account FROM chanlevs WHERE cid=%d;",cid);
      if (pg_num_rows(res)<1) {
        // no users left on the channel, part it
        strtolower(cargs[0]);
        pg_query("DELETE FROM channels WHERE lower(channel)='%s';",cargs[0]);
        send2up("%s L %s",target,cargs[0]);
        e[2]=1;
      }
      PQclear(res);
    } else if (e[3]==1) {
      pg_query("INSERT INTO chanlevs (account,cid,flags) VALUES ('%s',%ld,'%s');",acc,cid,tmp);
    } else if (e[3]==0) {
      strsort(tmp);
      strtolower(acc);
      pg_query("UPDATE chanlevs SET flags='%s' WHERE cid=%d AND lower(account)='%s';",tmp,cid,acc);
    } else {
      // nothing?
    }
    free(h);
    m_notice(unum,target,getlang(2128,gu(unum,1)),e[0],(e[0]==1) ? "" : "s",e[1],(e[1]==1) ? "" : "s");
    if (e[2]==1) {
      m_notice(unum,target,getlang(2129,gu(unum,1)));
    }

    return;
  } else {
    m_notice(unum,target,getlang(2130,gu(unum,1)));
    return;
  }
}

void load_cservice_cmd_chanlev(void) {
  chl_add(command_module,command_name,cservice_cmd_chanlev,command_oper,command_type,command_auth,command_desc);
}
