/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : help.c                                                      :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "clients.h"
#include "channels.h"
#include "dynhdl.h"

#define command_module "cservice"
#define command_name   "help"
#define command_desc   2156
#define command_oper   0
#define command_type   1
#define command_auth   0

void cservice_cmd_help(char *arg, char *unum, char *target) {
  strarray(arg); chl *a; int found=0;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2157,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2158,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  for(a=cmd_list;a!=NULL;a=a->next) {
    if (!strcmp(a->module,command_module) && !strcasecmp(a->command,cargs[0])) {
      m_notice(unum,target,"\02%s\02 %s",a->command,getlang(a->desc,gu(unum,1)));
      found=1;
    }
  }
  if (found==0) {
    m_notice(unum,target,getlang(2159,gu(unum,1)));
  }
}

void load_cservice_cmd_help(void) {
  chl_add(command_module,command_name,cservice_cmd_help,command_oper,command_type,command_auth,command_desc);
}
