/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : language.c, custom user languages.                          :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"

#define command_module "cservice"
#define command_name   "language"
#define command_desc   2341
#define command_oper   0
#define command_type   1
#define command_auth   1

void cservice_cmd_language(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; langlist *a; int b; users *c; char tmpacc[50];
  if (cargc==0) {
    m_notice(unum,target,getlang(2342,gu(unum,1)));
    m_notice(unum,target,"---");
    for(a=lang_list,b=0;a!=NULL;a=a->next,b++) {
      m_notice(unum,target,"\02%s\02 (%s)",a->name,getlang(1,a->name));
    }
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2344,gu(unum,1)),b);
    return;
  } else {
    for(a=lang_list,b=0;a!=NULL;a=a->next) {
      if (!strcasecmp(a->name,cargs[0])) b=1;
    }
    if (b==0) {
      m_notice(unum,target,getlang(2345,gu(unum,1)),cargs[0]);
      return;
    }
    strtolower(cargs[0]);
    resetchar(tmpacc);
    strcp(tmpacc,getauth(unum));
    strtolower(tmpacc);
    pg_query("UPDATE users SET lang='%s' WHERE lower(account)='%s';",cargs[0],tmpacc);
    c=uptr(unum);
    if (c!=NULL) {
      strncpy(c->lang,cargs[0],strlen(cargs[0]));
      c->lang[strlen(cargs[0])]=0x00;
    }
    m_notice(unum,target,getlang(2346,gu(unum,1)),cargs[0]);
    return;
  }
}

void load_cservice_cmd_language(void) {
  chl_add(command_module,command_name,cservice_cmd_language,command_oper,command_type,command_auth,command_desc);
}
