/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : passwd.c                                                    :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "channels.h"
#include "pgsql.h"

#define command_module "cservice"
#define command_name   "passwd"
#define command_desc   2382
#define command_oper   0
#define command_type   1
#define command_auth   0

void cservice_cmd_passwd(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; char hashpw[40],tmpacc[50];
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2383,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2384,gu(unum,1)));
    m_notice(unum,target,getlang(2385,gu(unum,1)));
    return;
  } else if (cargc<3) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  resetchar(hashpw);
  getmd5(cargs[0],hashpw);
  resetchar(tmpacc);
  strcp(tmpacc,getauth(unum));
  strtolower(tmpacc);
  res=pg_query("SELECT passwd FROM users WHERE lower(account)='%s';",tmpacc);
  if (pg_num_rows(res)<1) {
    PQclear(res);
    return;
  }
  if (strcmp(PQgetvalue(res,0,0),hashpw)) {
    m_notice(unum,target,getlang(2027,gu(unum,1)));
    PQclear(res);
    return;
  }
  if (strcmp(cargs[1],cargs[2])) {
    m_notice(unum,target,getlang(2386,gu(unum,1)));
    PQclear(res);
    return;
  }
  PQclear(res);
  resetchar(hashpw);
  getmd5(cargs[1],hashpw);
  pg_query("UPDATE users SET passwd='%s' WHERE account='%s';",hashpw,tmpacc);
  m_notice(unum,target,getlang(2387,gu(unum,1)));
}

void load_cservice_cmd_passwd(void) {
  chl_add(command_module,command_name,cservice_cmd_passwd,command_oper,command_type,command_auth,command_desc);
}
