/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : sendpass.c                                                  :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"

#define command_module "cservice"
#define command_name   "sendpass"
#define command_desc   2190
#define command_oper   0
#define command_type   1
#define command_auth   0

#define global_nicklen 20
#define passwd_lenght  8

void cservice_cmd_sendpass(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; unsigned int key=0,i,j; char tmps[20],tmpt[60],tmpt2[60],b64t[70],mailsub[512];
  strcpy(b64t,"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789[]");  
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2191,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2192,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (strlen(cargs[0])>global_nicklen) {
    m_notice(unum,target,getlang(2193,gu(unum,1)));
    return;
  }
  strtolower(cargs[0]);
  res=pg_query("SELECT email FROM users WHERE lower(account)='%s';",cargs[0]);
  if (res==NULL) {
    m_notice(unum,target,getlang(8217,gu(unum,1)));
    PQclear(res);
    return;
  }
  if (PQntuples(res)<1) {
    m_notice(unum,target,getlang(8211,gu(unum,1)),cargs[0]);
    PQclear(res);
    return;
  }
  /* generate new password */
  tmps[0]=0x00; tmpt[0]=0x00;
  srand(time(NULL));
  for(j=1;j<=passwd_lenght;j++) {
    i=rand()%strlen(b64t);
    sprintf(tmps,"%c",b64t[i]);
    strcat(tmpt,tmps);
  }
  tmpt[passwd_lenght]=0x00;
  resetchar(tmpt2);
  getmd5(tmpt,tmpt2);
  pg_query("UPDATE users SET passwd='%s' WHERE lower(account)='%s';",tmpt2,cargs[0]);
  sprintf(mailsub,"[%s]: %s",mconfig_get("network","GamerIRC"),getlang(2194,gu(unum,1)));
  mailsend(cargs[1],mailsub,getlang(2195,gu(unum,1)),getauth(unum),tmpt,mconfig_get("network","GamerIRC"));
  m_notice(unum,target,getlang(2196,gu(unum,1)));
  PQclear(res);
}

void load_cservice_cmd_sendpass(void) {
  chl_add(command_module,command_name,cservice_cmd_sendpass,command_oper,command_type,command_auth,command_desc);
}
