/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : showcommands.c                                              :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "dynhdl.h"

#define command_module "cservice"
#define command_name   "showcommands"
#define command_desc   8207
#define command_oper   0
#define command_type   1
#define command_auth   0

void cservice_cmd_showcommands(char *arg, char *unum, char *target) {
  chl *a; int gauth;
  m_notice(unum,target,getlang(8208,gu(unum,1)));
  m_notice(unum,target,"---");
  gauth=isauthed(unum);
  for(a=cmd_list;a!=NULL;a=a->next) {
    if ((!strcmp(a->module,command_module)) && a->active && a->type==1) {
      if (a->oper || (a->auth && !gauth)) continue;
      m_notice(unum,target,"\02%s\02 %s",a->command,getlang(a->desc,gu(unum,1)));
    }
  }
  if (isoper(unum)) {
    for(a=cmd_list;a!=NULL;a=a->next) {
      if ((!strcmp(a->module,command_module)) && a->active && a->type==1) {
        if (a->oper && isoper(unum) && (a->auth && gauth)) {
          m_notice(unum,target,"\02%s\02 %s (oper)",a->command,getlang(a->desc,gu(unum,1)));
        }
      }
    }
  }
  m_notice(unum,target,"---"); 
  m_notice(unum,target,getlang(8209,gu(unum,1)));
}

void load_cservice_cmd_showcommands(void) {
  chl_add(command_module,command_name,cservice_cmd_showcommands,command_oper,command_type,command_auth,command_desc);
}
