/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : unban.c                                                     :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"

#define command_module "cservice"
#define command_name   "unban"
#define command_desc   2235
#define command_oper   0
#define command_type   1
#define command_auth   1

void cservice_cmd_unban(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; int cid;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2236,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2059,gu(unum,1)));
    m_notice(unum,target,getlang(2237,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findchannel(cargs[0])) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  if (!cl_master(cargs[0],unum) && !cl_owner(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2238,gu(unum,1)));
    return;
  }
  cid=getcid(cargs[0]);
  res=pg_query("SELECT hostmask FROM bans WHERE cid='%ld' AND hostmask='%s';",cid,cargs[1]);
  if (PQntuples(res)<1) {
    m_notice(unum,target,getlang(2239,gu(unum,1)),cargs[1],cargs[0]);
    PQclear(res);
    return;
  }
  send2up("%s M %s -b %s",getmodsnum(command_module),cargs[0],cargs[1]);
  pg_query("DELETE FROM bans WHERE mask='%s' AND cid=%ld;",cargs[1],cid);
  m_notice(unum,target,getlang(2240,gu(unum,1)),cargs[1]);
  PQclear(res);
}

void load_cservice_cmd_unban(void) {
  chl_add(command_module,command_name,cservice_cmd_unban,command_oper,command_type,command_auth,command_desc);
}
