/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : unbanall.c                                                  :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "channels.h"
#include "configx.h"

#define command_module "cservice"
#define command_name   "unbanall"
#define command_desc   2388
#define command_oper   0
#define command_type   1
#define command_auth   1

void cservice_cmd_unbanall(char *arg, char *unum, char *target) {
  strarray(arg); chans *c; char *mynum;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2050,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2133,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findchannel(cargs[0])) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  if (!hascl(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2042,gu(unum,1)),cargs[0]);
    return;
  }
  if (!cl_master(cargs[0],unum) && !cl_owner(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(8202,gu(unum,1)));
    return;
  }
  c=cptr(cargs[0]);
  if (c==NULL) {
    return;
  }
  mynum=mconfig_get("numeric","JP");
  send2up("%s CM %s :b",mynum,cargs[0]);
  m_notice(unum,target,getlang(2389,gu(unum,1)));  
}

void load_cservice_cmd_unbanall(void) {
  chl_add(command_module,command_name,cservice_cmd_unbanall,command_oper,command_type,command_auth,command_desc);
}
