/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : unsuspendauth.c                                             :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"

#define command_module "cservice"
#define command_name   "unsuspendauth"
#define command_desc   2241
#define command_oper   1
#define command_type   1
#define command_auth   1

int findaccount(char *name) {
  PGresult *res;
  strtolower(name);
  res=pg_query("SELECT uid FROM users WHERE lower(account)='%s';",name);
  if (pg_num_rows(res)>0) {
    PQclear(res);
    return 1;
  } else {
    PQclear(res);
    return 0;
  }
}

void cservice_cmd_unsuspendauth(char *arg, char *unum, char *target) {
  strarray(arg); char account[512],reason[512],mailsub[200],mailtxt[512]; int i,users_hit=0,uid;
  long tst; users *a; PGresult *res;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2242,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2243,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findaccount(cargs[0])) {
    m_notice(unum,target,getlang(8211,gu(unum,1)),cargs[0]);
    return;
  }
  uid=getuserid(cargs[0]);
  res=pg_query("SELECT uid FROM accountsuspends WHERE uid=%d;",uid);
  if (pg_num_rows(res)<1) {
    m_notice(unum,target,getlang(2200,gu(unum,1)),cargs[0]);
    PQclear(res);
    return;
  }
  pg_query("DELETE FROM accountsuspends WHERE uid=%d;",uid);
  pg_query("UPDATE users SET suspended=FALSE WHERE uid=%d;",uid);
  PQclear(res);
  m_notice(unum,target,getlang(2244,gu(unum,1)),cargs[0]);
}

void load_cservice_cmd_unsuspendauth(void) {
  chl_add(command_module,command_name,cservice_cmd_unsuspendauth,command_oper,command_type,command_auth,command_desc);
}
