/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : whoami.c, Displays information about a user itself.         :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"

#define command_module "cservice"
#define command_name   "whoami"
#define command_desc   2295
#define command_oper   0
#define command_type   1
#define command_auth   0

void cservice_cmd_whoami(char *arg, char *unum, char *target) {
  cusers *a;
  m_notice(unum,target,getlang(2296,gu(unum,1)),num2nick(unum));
  if (isauthed(unum)) {
    m_notice(unum,target,getlang(2297,gu(unum,1)),getauth(unum));
  } else {
    m_notice(unum,target,getlang(2298,gu(unum,1)));
  }
  m_notice(unum,target,"---");
  for(a=cuser_list;a!=NULL;a=a->next) {
    if (!strcmp(a->unum,unum)) {
      m_notice(unum,target,getlang(2299,gu(unum,1)),a->name);
    }
  }
}

void load_cservice_cmd_whoami(void) {
  chl_add(command_module,command_name,cservice_cmd_whoami,command_oper,command_type,command_auth,command_desc);
}
