/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : average.c                                                   :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"

#define command_module "operserv"
#define command_name   "average"
#define command_desc   3000
#define command_oper   1
#define command_type   1
#define command_auth   1

void operserv_cmd_average(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; chans *a;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(3001,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(3002,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  a=cptr(cargs[0]);
  if (a==NULL) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  res=pg_query("SELECT channel,avg,checks,firstcheck FROM avgdata WHERE channel='%s'",cargs[0]);
  if (pg_num_rows(res)<1) {
    m_notice(unum,target,getlang(3003,gu(unum,1)));
    PQclear(res);
	return;
  }
  m_notice(unum,target,"*** Channel \02%s\02",PQgetvalue(res,0,0));
  m_notice(unum,target,getlang(3004,gu(unum,1)),atof(PQgetvalue(res,0,1)),atoi(PQgetvalue(res,0,2)));
  m_notice(unum,target,getlang(3005,gu(unum,1)),cctime((time_t)atol(PQgetvalue(res,0,3))));
  PQclear(res);
}

void load_operserv_cmd_average(void) {
  chl_add(command_module,command_name,operserv_cmd_average,command_oper,command_type,command_auth,command_desc);
}
