/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : kill.c                                                    :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"

#define command_module "operserv"
#define command_name   "kill"
#define command_desc   3024
#define command_oper   1
#define command_type   1
#define command_auth   1

void operserv_cmd_kill(char *arg, char *unum, char *target) {
  strarray(arg); char *usr; char reason[250]; int i;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(3025,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(3026,gu(unum,1)));
    m_notice(unum,target,getlang(3022,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  resetchar(reason);
  strcp(reason,"No reason given");
  if (cargc>=2) {
    resetchar(reason);
    for(i=1;i<cargc;i++) {
      strcat(reason,cargs[i]);
      if ((i+1)<cargc) {
        strcat(reason," ");
      }
    }
    reason[strlen(reason)]=0x00;
  }
  usr=nick2num(cargs[0]);
  if (usr==NULL) {
    m_notice(unum,target,getlang(8214,gu(unum,1)),cargs[0]);
    return;
  }
  send2up("%s D %s :%s (%s)",getmodsnum(command_module),usr,mconfig_get("servername","modserv.default.org"),reason);
  killuser(usr);
  m_notice(unum,target,getlang(3027,gu(unum,1)),cargs[0],reason);
}

void load_operserv_cmd_kill(void) {
  chl_add(command_module,command_name,operserv_cmd_kill,command_oper,command_type,command_auth,command_desc);
}
