/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : showchan.c                                                  :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"

#define command_module "operserv"
#define command_name   "showchan"
#define command_desc   3095
#define command_oper   1
#define command_type   1
#define command_auth   1

void operserv_cmd_showchan(char *arg, char *unum, char *target) {
  strarray(arg); chans *a; cusers *c; users *b; char tmpchan[201],tmps1[512],tmps2[512]; int myc,cc=0;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(3001,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(3002,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  a=cptr(cargs[0]);
  if (a==NULL) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  resetchar(tmpchan);
  strcp(tmpchan,a->name);
  strtolower(tmpchan);
  myc=getcid(tmpchan);
  resetchar(tmps1);
  resetchar(tmps2);
  sprintf(tmps1,"%s ",(myc==-1) ? getlang(8205,gu(unum,1)) : getlang(8204,gu(unum,1)));
  if (myc>-1) {
    sprintf(tmps2,"(#%ld)",myc);
    strcat(tmps1,tmps2);
  }
  m_notice(unum,target,getlang(3096,gu(unum,1)),a->name,tmpchan);
  m_notice(unum,target,getlang(3097,gu(unum,1)),cctime((time_t)a->created),a->created);
  m_notice(unum,target,getlang(3098,gu(unum,1)),tmps1);
  resetchar(tmps1);
  if (a->limit!=0) {
    inttostr(a->limit,tmps2);
  }
  a->modes[strlen(a->modes)]=0x00;
  sprintf(tmps1,"%s %s%s %s%s",(strlen(a->modes)==1 && a->modes[0]=='+') ? getlang(8220,gu(unum,1)) : a->modes,(a->key[0]=='\0') ? "" : "Key: ",(a->key[0]=='\0') ? "" : a->key,(a->limit==0) ? "" : "Limit: ",(a->limit==0) ? "" : tmps2);
  //m_notice(unum,target,getlang(3099,gu(unum,1)),tmps1);
  if (a->topic[0]!='\0') {
	m_notice(unum,target,getlang(3103,gu(unum,1)),a->topic);
  }
  m_notice(unum,target,"---");
  for(c=cuser_list;c!=NULL;c=c->next) {
    assert(c->name);
    assert(c->unum);
    if (!strcasecmp(a->name,c->name)) {
      resetchar(tmps1);
      if (IsOpped(c->flags)) {
        strcat(tmps1,"@");
      }
      if (IsVoiced(c->flags)) {
        strcat(tmps1,"+");
      }
      b=uptr(c->unum);
      assert(b);
      resetchar(tmps2);
      ++cc;
      if (b->auth[0]!='\0') {
        sprintf(tmps2,"%d. %s%s (%s@%s), auth: %s %s (hash: %s)",cc,tmps1,b->nick,b->ident,b->host,getlang(3100,gu(unum,1)),b->auth,b->hash);
      } else {
        sprintf(tmps2,"%d. %s%s (%s@%s), auth: %s (hash: %s)",cc,tmps1,b->nick,b->ident,b->host,getlang(3101,gu(unum,1)),b->hash);
      }
      m_notice(unum,target,tmps2);
    }
  }
}

void load_operserv_cmd_showchan(void) {
  chl_add(command_module,command_name,operserv_cmd_showchan,command_oper,command_type,command_auth,command_desc);
}
