/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : skick.c                                                     :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"

#define command_module "operserv"
#define command_name   "skick"
#define command_desc   3019
#define command_oper   1
#define command_type   1
#define command_auth   1

void operserv_cmd_skick(char *arg, char *unum, char *target) {
  strarray(arg); chans *a; cusers *c; char reason[200]; int i;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(3020,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2133,gu(unum,1)));
    m_notice(unum,target,getlang(3021,gu(unum,1)));
    m_notice(unum,target,getlang(3022,gu(unum,1)));
    return;
  } else if (cargc<2) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  a=cptr(cargs[0]);
  if (a==NULL) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  if (nick2num(cargs[1])==NULL) {
    m_notice(unum,target,getlang(8214,gu(unum,1)),cargs[1]);
    return;
  }
  c=cuptr(a->name,nick2num(cargs[1]));
  if (c==NULL) {
    return;
  }
  resetchar(reason);
  if (argc>=3) {
    for(i=2;i<argc-1;i++) {
      strcat(reason,cargs[i]);
      strcat(reason," ");
    }
    reason[strlen(reason)-1]=0x00;
  } else {
    strcp(reason,"no reason given");
  }
  send2up("%s K %s %s :%s",mconfig_get("numeric","JP"),a->name,c->unum,reason);
  delcuser(a->name,c->unum);
  m_notice(unum,target,getlang(3023,gu(unum,1)),cargs[1],a->name,reason);
}

void load_operserv_cmd_skick(void) {
  chl_add(command_module,command_name,operserv_cmd_skick,command_oper,command_type,command_auth,command_desc);
}
