/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : syncglines.c                                                :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"

#define command_module "operserv"
#define command_name   "syncglines"
#define command_desc   3042
#define command_oper   1
#define command_type   1
#define command_auth   1

void operserv_cmd_syncglines(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; int i=0;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(3043,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(3044,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  res=pg_query("SELECT mask,expirets,reason FROM glines;");
  if (pg_num_rows(res)<1) {
    m_notice(unum,target,getlang(3045,gu(unum,1)));
    PQclear(res);
    return;
  }
  for(i=0;i<pg_num_rows(res);i++) {
    send2up("%s GL %s +%s %s :%s",mconfig_get("numeric","JP"),cargs[0],PQgetvalue(res,i,0),PQgetvalue(res,i,1),PQgetvalue(res,i,2));
  }
  m_notice(unum,target,getlang(3046,gu(unum,1)),i);
  PQclear(res);
}

void load_operserv_cmd_syncglines(void) {
  chl_add(command_module,command_name,operserv_cmd_syncglines,command_oper,command_type,command_auth,command_desc);
}
