/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : clients.h, fakeclient handler                               :
   : (c) 2004 Christian Jurk                                     :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#ifndef _HAVE_CLIENTS
#define _HAVE_CLIENTS

#include <stdio.h>
#include <stdlib.h>
#include "ucdata.h"

#define valid_uflags "aeghp"

char resx[120];
void client_create(char *mod, char *nick, char *ident, char *host, char *modes, unsigned int auth, char *real);
void client_close(char *nick, char *quitmsg);
void client_join(char *nick, char *chan);
void client_part(char *nick, char *chan);
void setcumode(char *chan, char *unum, unsigned int modes);
void getmodnum(char *mod, char *res);
char *num2nick(char *unum);
char *nick2num(char *nick);
int isoper(char *unum);
users *uptr(char *unum);
unsigned int isauthed(char *unum);
char *getauth(char *unum);
void killuser(char *unum);
char *uflags(char *account);
char *getuflags(char *account);
int hasuflag(char *account, char flag);
int adduflag(char *account, char flag);
int deluflag(char *account, char flag);
int isvaliduflag(char flag);
int getuserid(char *name);
char *gu(char *item, int tyy);

#endif /* _HAVE_CLIENTS */
