/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : main.h, main program                                        :
   : (c) 2004 Christian Jurk                                     :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */
   
#ifndef _HAVE_MAIN
#define _HAVE_MAIN
   
#undef OS_BSD

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <time.h>
#include "memstr.h"
#include "lang.h"

#define modserv_version "2.001"
#define modserv_debug   1 
#define modserv_ircdvar "kotaro"
#define modserv_bufsize 513
#define modserv_base64  "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789[]"

#define stddef_nicklen  20
#define stddef_userlen  10
#define stddef_hostlen  70
#define stddef_authlen  20
#define stddef_modelen  20
#define stddef_unumlen  6
#define stddef_hashlen  33
#define stddef_langlen  20
#define stddef_maxmpln  6
#define stddef_addrlen  16

#define stdc_name       200
#define stdc_key        200
#define stdc_modes      15
#define stdc_topic      300

#define stdflags_cf     "abcekoptvw"
#define stdflags_cl     "abgimnoqtvw"
#define stdflags_uf     "aeghp"
#define stdflags_cm     "bcCdDiklmMnNoprsStTuvz"

#define delim           0x00
#define mTrue           1
#define mFalse          0

typedef unsigned int mBool;

time_t startup,linktime;
unsigned int burst,argc,global_debug,burstlines,lengths[10];
int sfd, have_eob, received_vctrl;
memstr *lastline;
char args[40][256];
char *snum,*hubnum;
char tmpv1[1024],tmpv2[1024];
mBool load_modules;

void core_get_argv(char *line);
void send2up(char *str, ...);
void shl_lserver();
void fillnull();
void cleanup(void);

#endif /* _HAVE_MAIN */
