/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : memstr.h, dynamic memory strings                            :
   : (c) 2004 Christian Jurk, portions Stephan Peijnik (dstring) :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#ifndef _HAVE_MEMSTR
#define _HAVE_MEMSTR

#include <stdio.h>
#include <stdlib.h>

typedef char *mstring;

typedef struct lmemstr {
	char *str;
	unsigned int len;
} memstr;

memstr *memstr_new(char *str);
memstr *memstr_replace(memstr *c, char *n);
memstr *memstr_free(memstr *c);

#endif /* _HAVE_MEMSTR */
