/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : modbas.h, basic module headers                              :
   : (c) 2004 Christian Jurk, portions Stephan Peijnik (dstring) :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */
   
#ifndef _HAVE_MODBAS
#define _HAVE_MODBAS

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include "clients.h"

#define max_cmdargs 10
#define max_arglen  128

char cargs[max_cmdargs][max_arglen];
unsigned int cargc;

void m_privmsg(char *unum, char *sender, char *msg, ...);
void m_notice(char *unum, char *sender, char *msg, ...);
void m_mode(char *sender, char *target, char *modestr, ...);
void strarray(char *arg);
mBool SendPriv(char *unum);

/* core.c */
unsigned int tmpflags,lastflags;

#endif /* _HAVE_MODBAS */
