/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : conf.c                                                      :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "dynhdl.h"
#include "configx.h"

#define command_module "core"
#define command_name   "conf"
#define command_desc   1102
#define command_oper   1
#define command_type   1
#define command_auth   1

void core_cmd_conf(char *arg, char *unum, char *target) {
  mconfig *c; unsigned int cx,si=0; char ty[20];
  strarray(arg);
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(1103,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(1104,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  m_notice(unum,target,getlang(1105,gu(unum,1)));
  for(cx=0,c=config_list;c!=NULL;c=c->next) {
    assert(c->item);
    /* Lock postgres data from the opers */
    if (c->item[0] == 'p' && c->item[1]=='g') continue;
    if (strmatch(cargs[0],c->item)) {
      c->val[c->len]=0x00;
      resetchar(ty);
      switch(c->type) {
        case TC_BOOL:
          strcp(ty,"Bool");
          si=4;
          break;
          
        case TC_INTEGER:
          strcp(ty,"Integer");
          si=4;
          break;
          
        case TC_STRING:
          strcp(ty,"String");
          si=(unsigned int)strlen(c->val);
          break;
      }
      cx++;
      m_notice(unum,target,getlang(1106,gu(unum,1)),cx," ",c->item,c->val,ty,si,c->cat);
    }
  }  
  if (cx==0) {
    m_notice(unum,target,getlang(1107,gu(unum,1)));
    return;
  }
}

void load_core_cmd_conf(void) {
  chl_add(command_module,command_name,core_cmd_conf,command_oper,command_type,command_auth,command_desc);
}
