/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : convnum.c                                                   :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "servers.h"
#include "modbas.h"
#include "clients.h"
#include "ucdata.h"
#include "lang.h"

#define command_module "core"
#define command_name   "convnum"
#define command_desc   1000
#define command_oper   1
#define command_type   1
#define command_auth   1

void core_cmd_convnum(char *arg, char *unum, char *target) {
  servers *a; users *d; char tmpnum[20];
  strarray(arg);
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(1001,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(1002,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  d = uptr(cargs[0]);
  if (d==NULL) {
    m_notice(unum,target,getlang(1003,gu(unum,1)));
  } else {
    resetchar(tmpnum);
    sprintf(tmpnum,"%c%c",cargs[0][0],cargs[0][1]);    
    for(a=serv_list;a!=NULL;a=a->next) {
      assert(a->snum);
      if (a->snum[0]==cargs[0][0] && a->snum[1]==cargs[0][1]) {
        m_notice(unum,target,getlang(1004,gu(unum,1)),cargs[0],d->nick,d->ident,d->host,a->name);
        return;
      }
    }
    m_notice(unum,target,"%s = %s",cargs[0],d->nick);
  }
}

void load_core_cmd_convnum(void) {
  chl_add(command_module,command_name,core_cmd_convnum,command_oper,command_type,command_auth,command_desc);
}
