/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : unloadcmd.c                                                 :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "dynhdl.h"

#define command_module "core"
#define command_name   "listcmds"
#define command_desc   1009
#define command_oper   1
#define command_type   1
#define command_auth   1

void core_cmd_listcmds(char *arg, char *unum, char *target) {
  chl *a; mhl *b; unsigned f=0,c=0;
  strarray(arg);
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(1011,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(1012,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  for(b=mod_list;b!=NULL;b=b->next) {
    if (!strcasecmp(b->name->str,cargs[0])) {
      f=1;
      m_notice(unum,target,getlang(1013,gu(unum,1)),b->name->str);
    }
  }
  if (!f) {
    m_notice(unum,target,getlang(1014,gu(unum,1)),cargs[0]);
    return;
  }
  m_notice(unum,target,"---");
  for(a=cmd_list;a!=NULL;a=a->next) {
    if (!strcasecmp(a->module,cargs[0])) {
      if (a->next!=NULL) {
        m_notice(unum,target,getlang(1015,gu(unum,1)),a->command,(a->oper) ? getlang(8204,gu(unum,1)) : getlang(8205,gu(unum,1)),(a->type==1) ? getlang(1017,gu(unum,1)) : getlang(1018,gu(unum,1)),(a->active) ? getlang(1019,gu(unum,1)) : getlang(1020,gu(unum,1)));
      } else {
        m_notice(unum,target,getlang(1016,gu(unum,1)),a->command,(a->oper) ? getlang(8204,gu(unum,1)) : getlang(8205,gu(unum,1)),(a->type==1) ? getlang(1017,gu(unum,1)) : getlang(1018,gu(unum,1)),(a->active) ? getlang(1019,gu(unum,1)) : getlang(1020,gu(unum,1)));
      }
      c++;
    }
  }
  m_notice(unum,target,"---");
  m_notice(unum,target,"%d %s listed.",c,((c>1)&&(c!=0)) ? "commands" : "command");
}

void load_core_cmd_listcmds(void) {
  chl_add(command_module,command_name,core_cmd_listcmds,command_oper,command_type,command_auth,command_desc);
}
