/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : reloadcmd.c                                                 :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "dynhdl.h"

#define command_module "core"
#define command_name   "reloadcmd"
#define command_desc   1044
#define command_oper   1
#define command_type   1
#define command_auth   1

void core_cmd_reloadcmd(char *arg, char *unum, char *target) {
  chl *a; char tmp[20]; int state[3];
  strarray(arg);
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(1045,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(1034,gu(unum,1)));
    m_notice(unum,target,getlang(1046,gu(unum,1)));
    return;
  } else if (cargc<2) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  for(a=cmd_list;a!=NULL;a=a->next) {
    if (!a->command || a->command==NULL) continue;
    if (!a->module || a->module==NULL) continue;
    if (!strcasecmp(a->command,cargs[1]) && !strcasecmp(a->module,cargs[0])) {
      state[0] = unloadcmd(cargs[0], cargs[1], a->type);
      state[1] = loadcommand(cargs[0], "0", "1", cargs[1]);
      if (state[0] && state[1]) {
        m_notice(unum,target,getlang(1047,gu(unum,1)),cargs[1]);
        return;
      } else {
        m_notice(unum,target,getlang(1048,gu(unum,1)),cargs[1],(state[0]==0) ? getlang(1050,gu(unum,1)) : getlang(1049,gu(unum,1)));
        return;
      }
    }
  }
}

void load_core_cmd_reloadcmd(void) {
  chl_add(command_module,command_name,core_cmd_reloadcmd,command_oper,command_type,command_auth,command_desc);
}
