/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : servers.c                                                 :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "dynhdl.h"
#include "servers.h"
#include "ucdata.h"

#define command_module "core"
#define command_name   "servers"
#define command_desc   1057
#define command_oper   1
#define command_type   1
#define command_auth   1

void core_cmd_servers(char *arg, char *unum, char *target) {
  servers *sc; users *c; unsigned int a=0,cli; char type[20];
  for(sc=serv_list;sc!=NULL;sc=sc->next) {
    cli=0;
    for(c=user_list;c!=NULL;c=c->next) {
      assert(c->unum);
      assert(sc->snum);
      if (c->unum[0]==sc->snum[0] && c->unum[1]==sc->snum[1]) { cli++; }
    }
    if (chrstr('h',sc->flags)) {
      strcpy(type,"hub/leaf");
    } else if (chrstr('s',sc->flags)) {
      strcpy(type,"service");
    } else if (chrstr('l',sc->flags)) {
      strcpy(type,"leaf/hub");
    } else {
      strcpy(type,getlang(8206,gu(unum,1)));
    }
    m_notice(unum,target,"\02%s\02 [numeric %c%c] ",sc->name,sc->snum[0],sc->snum[1]);
    m_notice(unum,target,getlang(1058,gu(unum,1)),type,cctime(sc->bursttime));
    m_notice(unum,target,getlang(1059,gu(unum,1)),(64*64*64),cli);
    if (sc->next!=NULL) {
      m_notice(unum,target,"---");
    }
  }
}

void load_core_cmd_servers(void) {
  chl_add(command_module,command_name,core_cmd_servers,command_oper,command_type,command_auth,command_desc);
}
