/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : status.c                                                    :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "dynhdl.h"
#include "pgsql.h"
#include "ucdata.h"
#include "yalloc.h"

#define command_module "core"
#define command_name   "status"
#define command_desc   1060
#define command_oper   1
#define command_type   1
#define command_auth   0

void core_cmd_status(char *arg, char *unum, char *target) {
  chl *a; mhl *b; shl *c; users *d; chans *e; char tmpvar[60];
  unsigned int a1=0,a2=0,a3=0,a4=0,a5=0,bt=0;
  for(a=cmd_list;a!=NULL;a=a->next) a1++;
  for(b=mod_list;b!=NULL;b=b->next) a2++;
  for(c=shl_list;c!=NULL;c=c->next) a3++;
  for(d=user_list;d!=NULL;d=d->next) {
    a4++;
    //printf("user_list(%s),d->next(%s)\n",d->nick,(d->next==NULL) ? "NULL" : d->next->nick);
  }
  for(e=chan_list;e!=NULL;e=e->next) a5++;
  resetchar(tmpvar);
  bt=startup-linktime;
  durationcp(time(NULL)-startup,tmpvar);
  m_notice(unum,target,getlang(1061,gu(unum,1)),modserv_version,__DATE__,__TIME__);
  m_notice(unum,target,getlang(1062,gu(unum,1)));
  m_notice(unum,target,getlang(1063,gu(unum,1)),ctime(&startup));
  m_notice(unum,target,getlang(1064,gu(unum,1)),bt,burstlines,(burstlines>1) ? "s" : "");
  m_notice(unum,target,"   Uptime: %s",tmpvar);
  m_notice(unum,target,getlang(1065,gu(unum,1)));
  m_notice(unum,target," Commands: %d",a1);
  m_notice(unum,target,"  Modules: %d",a2);
  m_notice(unum,target,"     SHLs: %d",a3);
  m_notice(unum,target,"MyAlloced: %ld byte(s)",bytecounter);
  m_notice(unum,target,getlang(1066,gu(unum,1)));
  m_notice(unum,target,"    Users: %d",a4);
  m_notice(unum,target," Channels: %d",a5);
  m_notice(unum,target,getlang(1067,gu(unum,1)));
  m_notice(unum,target,"  Connect: %s",ctime(&pg_startup));
  m_notice(unum,target,"   Querys: %d",pg_querys);
  m_notice(unum,target," Queryavg: %d queries/sec.",(pg_startup==0 || pg_querys==0) ? 0 : (pg_querys/(time(NULL)-pg_startup)));
}

void load_core_cmd_status(void) {
  chl_add(command_module,command_name,core_cmd_status,command_oper,command_type,command_auth,command_desc);
}
