/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : activate.c                                                  :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "dynhdl.h"
#include "pgsql.h"
#include "clients.h"

#define command_module "cservice"
#define command_name   "activate"
#define command_desc   2000
#define command_oper   0
#define command_type   1
#define command_auth   0

void cservice_cmd_activate(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; char mailsub[250];
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2001,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2002,gu(unum,1)));
    m_notice(unum,target,getlang(2003,gu(unum,1)));
    return;
  } else if (cargc<2) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  strtolower(cargs[0]);
  res=pg_query("SELECT account,activated,actcode,passwd,email FROM users WHERE lower(account)='%s';",cargs[0]);
  if (pg_num_rows(res)<1) {
    m_notice(unum,target,getlang(2004,gu(unum,1)),cargs[0]);
    PQclear(res);
    return;
  }
  if (!strcmp(PQgetvalue(res,0,1),"t")) {
    m_notice(unum,target,getlang(2005,gu(unum,1)),PQgetvalue(res,0,0));
    PQclear(res);
    return;
  }
  if (strcmp(PQgetvalue(res,0,2),cargs[1])) {
    m_notice(unum,target,getlang(2006,gu(unum,1)));
    PQclear(res);
    return;
  }
  sprintf(mailsub,"[%s]: %s",mconfig_get("network","GamerIRC"),getlang(2007,gu(unum,1)));
  pg_query("UPDATE users SET activated=TRUE WHERE lower(account)='%s';",cargs[0]);
  mailsend(PQgetvalue(res,0,4),mailsub,getlang(2008,gu(unum,1)),PQgetvalue(res,0,0),PQgetvalue(res,0,0),mconfig_get("webaccess","http://cs.gamerirc.org/"),mconfig_get("helpchan","#help"));
  m_notice(unum,target,getlang(2009,gu(unum,1)),PQgetvalue(res,0,0));
  m_notice(unum,target,getlang(2010,gu(unum,1)),getmodnick(command_module),mconfig_get("servername","modserv.default.org"),PQgetvalue(res,0,0));
  m_notice(unum,target,getlang(2011,gu(unum,1)),mconfig_get("network","GamerIRC"));
  m_notice(unum,target,getlang(2012,gu(unum,1)),mconfig_get("helpchan","#help"));
}

void load_cservice_cmd_activate(void) {
  chl_add(command_module,command_name,cservice_cmd_activate,command_oper,command_type,command_auth,command_desc);
}
