/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : asciiart.c                                                  :
   : (c) 2005 GamerIRC dev-workx.                                :
   : ASCII arts powered by scopie.com                            :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "channels.h"
#include "pgsql.h"

#define command_module "cservice"
#define command_name   "asciiart"
#define command_desc   2378
#define command_oper   1
#define command_type   1
#define command_auth   1

void cservice_cmd_asciiart(char *arg, char *unum, char *target) {
  strarray(arg); chans *c;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2379,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2133,gu(unum,1)));
    m_notice(unum,target,getlang(2380,gu(unum,1)));
    return;
  } else if (cargc<2) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findchannel(cargs[0])) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  c=cptr(cargs[0]);
  if (c==NULL) {
    return;
  }
  if (!strcmp(cargs[1],"getall")) {
    m_notice(unum,target,getlang(2381,gu(unum,1)));
    m_notice(unum,target,"---");
    m_notice(unum,target,"pinky-brain, beavis, happybirthday, butterfly, cat,");
    m_notice(unum,target,"cow, frog, hellokitty, kangaroo, mouse,");
    m_notice(unum,target,"renandstimpy, sheep, homer, snake, moo.");
    return;
  }
  if (!strcmp(cargs[1],"pinky-brain")) {
    m_privmsg(cargs[0],target,"                                     ,.   '\\'\\    ,---.");
    m_privmsg(cargs[0],target,"     Quiet, Pinky; I'm pondering.    | \\\\  l\\l_ //    |   Err ... right,");
    m_privmsg(cargs[0],target,"            _              _         |  \\\\/ `/  `.|    |   Brain!  Narf!");
    m_privmsg(cargs[0],target,"          /~\\\\   \\        //~\\       | Y |   |   ||  Y |");
    m_privmsg(cargs[0],target,"          |  \\\\   \\      //  |       |  \\|   |   |\\\\ /  |   /");
    m_privmsg(cargs[0],target,"          [   ||        ||   ]       \\   |  o|o  | >  /   /");
    m_privmsg(cargs[0],target,"         ] Y  ||        ||  Y [       \\___\\_--_ /_/__/");
    m_privmsg(cargs[0],target,"         |  \\_|l,------.l|_/  |       /.-\\(____) /--.\\");
    m_privmsg(cargs[0],target,"         |   >'          `<   |       `--(______)----'");
    m_privmsg(cargs[0],target,"         \\  (/~`--____--'~\\)  /           U// U / \\");
    m_privmsg(cargs[0],target,"          `-_>-__________-<_-'            / \\  / /|");
    m_privmsg(cargs[0],target,"              /(_#(__)#_)\\               ( .) / / ]");
    m_privmsg(cargs[0],target,"              \\___/__\\___/                `.`' /   [");
    m_privmsg(cargs[0],target,"               /__`--'__\\                  |`-'    |");
    m_privmsg(cargs[0],target,"            /\\\\(__,>-~~ __)                 |       |__");
    m_privmsg(cargs[0],target,"         /\\\\//\\(  `--~~ )                 _l       |--:.");
    m_privmsg(cargs[0],target,"         '\\\\/  <^\\      /^>               |  `   (  <   \\\\");
    m_privmsg(cargs[0],target,"              _\\ >-__-< /_             ,-\\  ,-~~->. \\   `:.___,/");
    m_privmsg(cargs[0],target,"             (___\\    /___)           (____/    (____)    `---'    ");
    return;
  }
  if (!strcmp(cargs[1],"beavis")) {
    m_privmsg(cargs[0],target,"          ________________  ");
    m_privmsg(cargs[0],target,"         /                \\");
    m_privmsg(cargs[0],target,"        / /          \\ \\   \\");
    m_privmsg(cargs[0],target,"        |                  |");
    m_privmsg(cargs[0],target,"       /                  /");
    m_privmsg(cargs[0],target,"      |      ___\\ \\| | / / ");
    m_privmsg(cargs[0],target,"      |      /          \\  ");
    m_privmsg(cargs[0],target,"      |      |           \\ ");
    m_privmsg(cargs[0],target,"     /       |      _    | ");
    m_privmsg(cargs[0],target,"     |       |       \\   | ");
    m_privmsg(cargs[0],target,"     |       |       _\\ /| ");
    m_privmsg(cargs[0],target,"     |      __\\     <_o)\\o-     I am the");
    m_privmsg(cargs[0],target,"     |     |             \\      great Kornholio.");
    m_privmsg(cargs[0],target,"      \\    ||             \\      /");
    m_privmsg(cargs[0],target,"       |   |__          _  \\    /   Heh heh~");
    m_privmsg(cargs[0],target,"       |   |           (*___)  /");
    m_privmsg(cargs[0],target,"       |   |       _     |    /");
    m_privmsg(cargs[0],target,"       |   |    //_______/      ");
    m_privmsg(cargs[0],target,"       |  /       | UUUUU__     ");
    m_privmsg(cargs[0],target,"        \\|        \\_nnnnnn_\\-\\");
    m_privmsg(cargs[0],target,"         |       ____________/");
    m_privmsg(cargs[0],target,"         |      /    ");
    m_privmsg(cargs[0],target,"         |_____/       ");
    return;
  }
  if (!strcmp(cargs[1],"happybirthday")) {
    m_privmsg(cargs[0],target,"                      {}");
    m_privmsg(cargs[0],target,"                      ||");
    m_privmsg(cargs[0],target,"                  ____||_____");
    m_privmsg(cargs[0],target,"             {}  {~ ~ ~ ~ ~ ~}  {}");
    m_privmsg(cargs[0],target,"             ||  { ~ ~ ~ ~ ~ }  ||");
    m_privmsg(cargs[0],target,"           __||__{___________}__||__");
    m_privmsg(cargs[0],target,"          {\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\}");
    m_privmsg(cargs[0],target,"       {} {        H a p p y       \\} {}");
    m_privmsg(cargs[0],target,"       || {\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\} ||");
    m_privmsg(cargs[0],target,"     __||_{_________________________}_||__");
    m_privmsg(cargs[0],target,"    {\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\}");
    m_privmsg(cargs[0],target,"    {                                     }");
    m_privmsg(cargs[0],target,"    {         B i r t h d a y ! ! !       }");
    m_privmsg(cargs[0],target,"    {                                     }");
    m_privmsg(cargs[0],target,"    {/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/\\/}");
    m_privmsg(cargs[0],target,"    {_____________________________________}");
    return;
  }
  if (!strcmp(cargs[1],"butterfly")) {
    m_privmsg(cargs[0],target,"   _--_                                     _--_");
    m_privmsg(cargs[0],target," /#()# #\\         0             0         /# #()#\\");
    m_privmsg(cargs[0],target," |()##  \\#\\_       \\           /       _/#/  ##()|");
    m_privmsg(cargs[0],target," |#()##-=###\\_      \\         /      _/###=-##()#|");
    m_privmsg(cargs[0],target,"  \\#()#-=##  #\\_     \\       /     _/#  ##=-#()#/");
    m_privmsg(cargs[0],target,"   |#()#--==### \\_    \\     /    _/ ###==--#()#|");
    m_privmsg(cargs[0],target,"   |#()##--=#    #\\_   \\!!!/   _/#    #=--##()#|");
    m_privmsg(cargs[0],target,"    \\#()##---===####\\   O|O   /####===---##()#/");
    m_privmsg(cargs[0],target,"     |#()#____==#####\\ / Y \\ /#####==____#()#|");
    m_privmsg(cargs[0],target,"      \\###______######|\\/#\\/|######______###/");
    m_privmsg(cargs[0],target,"         ()#O#/      ##\\_#_/##      \\#O#()");
    m_privmsg(cargs[0],target,"        ()#O#(__-===###/ _ \\###===-__)#O#()");
    m_privmsg(cargs[0],target,"       ()#O#(   #  ###_(_|_)_###  #   )#O#()");
    m_privmsg(cargs[0],target,"       ()#O(---#__###/ (_|_) \\###__#---)O#()");
    m_privmsg(cargs[0],target,"       ()#O#( / / ##/  (_|_)  \\## \\ \\ )#O#()");
    m_privmsg(cargs[0],target,"       ()##O#\\_/  #/   (_|_)   \\#  \\_/#O##()");
    m_privmsg(cargs[0],target,"        \\)##OO#\\ -)    (_|_)    (- /#OO##(/");
    m_privmsg(cargs[0],target,"         )//##OOO*|    / | \\    |*OOO##\\(");
    m_privmsg(cargs[0],target,"         |/_####_/    ( /X\\ )    \\_####_\\|");
    m_privmsg(cargs[0],target,"        /X/ \\__/       \\___/       \\__/ \\X\\");
    m_privmsg(cargs[0],target,"       (#/                               \\#)");
    return;
  }
  if (!strcmp(cargs[1],"cat")) {
    m_privmsg(cargs[0],target,"    (\"`-''-/\").___..--''\"`-._");
    m_privmsg(cargs[0],target,"     `6_ 6  )   `-.  (     ).`-.__.`)");
    m_privmsg(cargs[0],target,"     (_Y_.)'  ._   )  `._ `. ``-..-'");
    m_privmsg(cargs[0],target,"   _..`--'_..-_/  /--'_.' ,'");
    m_privmsg(cargs[0],target,"  (il),-''  (li),'  ((!.-'    ");
    return;
  }
  if (!strcmp(cargs[1],"cow")) {
    m_privmsg(cargs[0],target,"         (__)             (__)             (__)");
    m_privmsg(cargs[0],target,"         (oo)             (oo)             (oo)");
    m_privmsg(cargs[0],target,"  /-------\\/       /-------\\/       /-------\\/");
    m_privmsg(cargs[0],target," / |     ||       / |     ||       / |     ||");
    m_privmsg(cargs[0],target,"*  ||----||      *  ||W---||      *  ||w---||");
    m_privmsg(cargs[0],target,"   ^^    ^^         ^^    ^^         ^^    ^^");
    m_privmsg(cargs[0],target,"     Cow           Cow laden        Same cow");
    m_privmsg(cargs[0],target,"                   with milk     after milking");
    return;
  }
  if (!strcmp(cargs[1],"frog")) {
    m_privmsg(cargs[0],target,"              .--._.--.");
    m_privmsg(cargs[0],target,"             ( O     O )");
    m_privmsg(cargs[0],target,"             /   . .   \\");
    m_privmsg(cargs[0],target,"            .`._______.'.");
    m_privmsg(cargs[0],target,"           /(           )\\");
    m_privmsg(cargs[0],target,"         _/  \\  \\   /  /  \\_");
    m_privmsg(cargs[0],target,"      .~   `  \\  \\ /  /  '   ~.");
    m_privmsg(cargs[0],target,"     {    -.   \\  V  /   .-    }");
    m_privmsg(cargs[0],target,"   _ _`.    \\  |  |  |  /    .'_ _");
    m_privmsg(cargs[0],target,"   >_       _} |  |  | {_       _<");
    m_privmsg(cargs[0],target,"    /. - ~ ,_-'  .^.  `-_, ~ - .\\");
    return;
  }
  if (!strcmp(cargs[1],"hellokitty")) {
    m_privmsg(cargs[0],target,"original Kitty apparently done by \"B.K.Bullock\"");
    m_privmsg(cargs[0],target,"smoothed out by yours truly. =^)");
    m_privmsg(cargs[0],target,"                __                             ___            _aaaa");
    m_privmsg(cargs[0],target,"               d8888aa,_                    a8888888a   __a88888888b");
    m_privmsg(cargs[0],target,"              d8P   `Y88ba.                a8P'~~~~Y88a888P\"\"~~~~Y88b");
    m_privmsg(cargs[0],target,"             d8P      ~\"Y88a____aaaaa_____a8P        888          Y88");
    m_privmsg(cargs[0],target,"            d8P          ~Y88\"8~~~~~~~88888P          88g          88");
    m_privmsg(cargs[0],target,"           d8P                           88      ____ _88y__       88b");
    m_privmsg(cargs[0],target,"           88                           a88    _a88~8888\"8M88a_____888");
    m_privmsg(cargs[0],target,"           88                           88P    88  a8\"'     `888888888b_");
    m_privmsg(cargs[0],target,"          a8P                           88     88 a88         88b     Y8,");
    m_privmsg(cargs[0],target,"           8b                           88      8888P         388      88b");
    m_privmsg(cargs[0],target,"          a88a                          Y8b       88L         8888.    88P");
    m_privmsg(cargs[0],target,"         a8P                             Y8_     _888       _a8P 88   a88");
    m_privmsg(cargs[0],target,"        _8P                               ~Y88a888~888g_   a888yg8'  a88'");
    m_privmsg(cargs[0],target,"        88                                   ~~~~    ~\"\"8888        a88P");
    m_privmsg(cargs[0],target,"       d8'                                                Y8,      888L");
    m_privmsg(cargs[0],target,"       8E                                                  88a___a8\"888");
    m_privmsg(cargs[0],target,"      d8P                                                   ~Y888\"   88L");
    m_privmsg(cargs[0],target,"      88                                                      ~~      88");
    m_privmsg(cargs[0],target,"      88                                                              88");
    m_privmsg(cargs[0],target,"      88                                                              88b");
    m_privmsg(cargs[0],target,"  ____88a_.      a8a                                                __881");
    m_privmsg(cargs[0],target,"88\"\"P~888        888b                                 __          8888888888");
    m_privmsg(cargs[0],target,"      888        888P                                d88b             88");
    m_privmsg(cargs[0],target,"     _888ba       ~            aaaa.                 8888            d8P");
    m_privmsg(cargs[0],target," a888~\"Y88                    888888                 \"8P          8aa888_");
    m_privmsg(cargs[0],target,"        Y8b                   Y888P\"                                88\"\"888a");
    m_privmsg(cargs[0],target,"        _88g8                  ~~~                                 a88    ~~");
    m_privmsg(cargs[0],target,"    __a8\"888_                                                  a_ a88");
    m_privmsg(cargs[0],target,"   88\"'    \"88g                                                 \"888g_");
    m_privmsg(cargs[0],target,"   ~         `88a_                                            _a88'\"Y88gg,");
    m_privmsg(cargs[0],target,"                \"888aa_.                                   _a88\"'      ~88");
    m_privmsg(cargs[0],target,"                   ~~\"\"8888aaa______                ____a888P'");
    m_privmsg(cargs[0],target,"                           ~~\"\"\"\"\"\"888888888888888888\"\"~~~");
    m_privmsg(cargs[0],target,"                                      ~~~~~~~~~~~~  ");
    return;
  }
  if (!strcmp(cargs[1],"kangaroo")) {
    m_privmsg(cargs[0],target,"                  .");
    m_privmsg(cargs[0],target,"              /\\ /l");
    m_privmsg(cargs[0],target,"             ((.Y(!"); 
    m_privmsg(cargs[0],target,"              \\ |/");
    m_privmsg(cargs[0],target,"              /  6~6,");
    m_privmsg(cargs[0],target,"             \\ _    +-.");
    m_privmsg(cargs[0],target,"               \\`-=--^-'");
    m_privmsg(cargs[0],target,"                \\ \\");   
    m_privmsg(cargs[0],target,"              _/  \\");
    m_privmsg(cargs[0],target,"              (  .  Y");
    m_privmsg(cargs[0],target,"             /\"\\ `--^--v--.");
    m_privmsg(cargs[0],target,"            / _ `--\"T~\\/~\\/");
    m_privmsg(cargs[0],target,"           / \" ~\\.  !");
    m_privmsg(cargs[0],target,"     _    Y      Y./'");
    m_privmsg(cargs[0],target,"    Y^|   |      |~~7");
    m_privmsg(cargs[0],target,"    | l   |     / ./'");  
    m_privmsg(cargs[0],target,"    | `L  | Y .^/~T");
    m_privmsg(cargs[0],target,"    |  l  ! | |/| |");
    m_privmsg(cargs[0],target,"    | .`\\/' | Y | !");
    m_privmsg(cargs[0],target,"    l  \"~   j l j_L______");
    m_privmsg(cargs[0],target,"     \\,____{ __\"~ __ ,\\_,\\_");
    m_privmsg(cargs[0],target," ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
    return;
  }
  if (!strcmp(cargs[1],"mouse")) {
    m_privmsg(cargs[0],target,"   _____             _____");
    m_privmsg(cargs[0],target,"  / ___ \\           / ___ \\");
    m_privmsg(cargs[0],target," / /   \\ \\_________/ /   \\ \\");
    m_privmsg(cargs[0],target,"| |     _/ \\    / \\_      | |");
    m_privmsg(cargs[0],target," \\     /  ^ \\  / ^  \\      /");
    m_privmsg(cargs[0],target,"  \\   |  | | \\/ | |  |    /");
    m_privmsg(cargs[0],target,"  /   |  |O|    |O|  |    \\");  
    m_privmsg(cargs[0],target," |__ /------ @@ -------\\ __|");
    m_privmsg(cargs[0],target,"  \\     __   @@   __      /");
    m_privmsg(cargs[0],target,"   \\      \\______/       /");
    m_privmsg(cargs[0],target,"    \\__     \\__/      __/");    
    m_privmsg(cargs[0],target,"       \\_____________/");
    return;
  }
  if (!strcmp(cargs[1],"renandstimpy")) {
    m_privmsg(cargs[0],target,"         ____           .    _  .");     
    m_privmsg(cargs[0],target,"        /# /_\\_         |\\_|/__/|");   
    m_privmsg(cargs[0],target,"       |  |/o\\o\\       / / \\/ \\  \\");  
    m_privmsg(cargs[0],target,"       |  \\\\_/_/      /__|O||O|__ \\");  
    m_privmsg(cargs[0],target,"      / |_   |       |/_ \\_/\\_/ _\\ |");  
    m_privmsg(cargs[0],target,"     |  ||\\_ ~|      | | (____) | ||");  
    m_privmsg(cargs[0],target,"     |  ||| \\/       \\/\\___/\\__/  //");   
    m_privmsg(cargs[0],target,"     |  |||_         (_/         ||");   
    m_privmsg(cargs[0],target,"      \\//  |          |          ||");    
    m_privmsg(cargs[0],target,"       ||  |          |          ||\\");   
    m_privmsg(cargs[0],target,"       ||_  \\          \\        //_/");      
    m_privmsg(cargs[0],target,"       \\_|  o|          \\______//");       
    m_privmsg(cargs[0],target,"       /\\___/         __ || __||");       
    m_privmsg(cargs[0],target,"      /  ||||__      (____(____)");     
    m_privmsg(cargs[0],target,"         (___)_)     REN & STIMPY!");
    return;
  }
  if (!strcmp(cargs[1],"sheep")) {
    m_privmsg(cargs[0],target,"                      /\\___"); 
    m_privmsg(cargs[0],target,"           @@@@@@@@@@@  O  \\");
    m_privmsg(cargs[0],target,"        @@@@@@@@@@@@@@@____/");
    m_privmsg(cargs[0],target,"       @@@@@@@@@@@@@@@@");  
    m_privmsg(cargs[0],target,"       @ @@@@@@@@@@@@"); 
    m_privmsg(cargs[0],target,"          ||      ||");
    m_privmsg(cargs[0],target,"          ~~      ~~");
    return;
  }
  if (!strcmp(cargs[1],"homer")) {
    m_privmsg(cargs[0],target,"           ___  _____  ");
    m_privmsg(cargs[0],target,"         .'/,-Y\"     \"~-.");
    m_privmsg(cargs[0],target,"         l.Y             ^.");
    m_privmsg(cargs[0],target,"         /\\               _\\_      \"Doh!\"");
    m_privmsg(cargs[0],target,"        i            ___/\"   \"\\");
    m_privmsg(cargs[0],target,"        |          /\"   \"\\   o !");
    m_privmsg(cargs[0],target,"        l         ]     o !__./");
    m_privmsg(cargs[0],target,"         \\ _  _    \\.___./    \"~\\");
    m_privmsg(cargs[0],target,"          X \\/ \\            ___./");
    m_privmsg(cargs[0],target,"         ( \\ ___.   _..--~~\"   ~`-.");
    m_privmsg(cargs[0],target,"          ` Z,--   /               \\");
    m_privmsg(cargs[0],target,"            \\__.  (   /       ______)");
    m_privmsg(cargs[0],target,"              \\   l  /-----~~\" /");
    m_privmsg(cargs[0],target,"               Y   \\          /");
    m_privmsg(cargs[0],target,"               |    \"x______.^");
    m_privmsg(cargs[0],target,"               |           \\");
    m_privmsg(cargs[0],target,"               j            Y");
    return;
  }
  if (!strcmp(cargs[1],"snake")) {
    m_privmsg(cargs[0],target,"    _________         _________");
    m_privmsg(cargs[0],target,"   /         \\       /         \\"); 
    m_privmsg(cargs[0],target,"  /  /~~~~~\\  \\     /  /~~~~~\\  \\");
    m_privmsg(cargs[0],target,"  |  |     |  |     |  |     |  |");
    m_privmsg(cargs[0],target,"  |  |     |  |     |  |     |  |");
    m_privmsg(cargs[0],target,"  |  |     |  |     |  |     |  |         /");
    m_privmsg(cargs[0],target,"  |  |     |  |     |  |     |  |       //");
    m_privmsg(cargs[0],target," (o  o)    \\  \\_____/  /     \\  \\_____/ /");
    m_privmsg(cargs[0],target,"  \\__/      \\         /       \\        /");
    m_privmsg(cargs[0],target,"   |         ~~~~~~~~~         ~~~~~~~~");
    m_privmsg(cargs[0],target,"   ^");
    return;
  }
  if (!strcmp(cargs[1],"moo")) {
    m_privmsg(cargs[0],target,"(__)");
    m_privmsg(cargs[0],target," oo\\\\\\~");
    m_privmsg(cargs[0],target,"  !!!!");
    return;
  }
}

void load_cservice_cmd_asciiart(void) {
  chl_add(command_module,command_name,cservice_cmd_asciiart,command_oper,command_type,command_auth,command_desc);
}
