/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : devoiceall.c                                                :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "channels.h"
#include "configx.h"

#define command_module "cservice"
#define command_name   "devoiceall"
#define command_desc   2349
#define command_oper   0
#define command_type   1
#define command_auth   1

void cservice_cmd_devoiceall(char *arg, char *unum, char *target) {
  strarray(arg); unsigned int i,devoiced=0; cusers *b; chans *c; char *mynum; char ulist[520],cmo[20];
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2362,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2133,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findchannel(cargs[0])) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  if (!hascl(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2042,gu(unum,1)),cargs[0]);
    return;
  }
  if (!cl_master(cargs[0],unum) && !cl_owner(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(8202,gu(unum,1)));
    return;
  }
  c=cptr(cargs[0]);
  if (c==NULL) {
    return;
  }
  resetchar(ulist);
  resetchar(cmo);
  mynum=mconfig_get("numeric","JP");
  send2up("%s CM %s :v",mynum,cargs[0]);
  for(b=cuser_list;b!=NULL;b=b->next) {
    if (!strcmp(b->name,c->name) && IsVoiced(b->flags)) {
      ClrVoiced(b->flags);
      devoiced++;
    }
  }
  m_notice(unum,target,getlang(2363,gu(unum,1)),devoiced,(devoiced==1) ? "" : "s",c->name);  
}

void load_cservice_cmd_devoiceall(void) {
  chl_add(command_module,command_name,cservice_cmd_devoiceall,command_oper,command_type,command_auth,command_desc);
}
