/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : email.c                                                      :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"

#define command_module "cservice"
#define command_name   "email"
#define command_desc   2145
#define command_oper   0
#define command_type   1
#define command_auth   1

#define verifypage     "http://my.gamerirc.org/verify/"

void cservice_cmd_email(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; unsigned int key=0,i; char mailsub[512],tmpacc[50];
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2146,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2147,gu(unum,1)));
    m_notice(unum,target,getlang(2148,gu(unum,1)));
    return;
  } else if (cargc<3) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (strcasecmp(cargs[1],cargs[2])) {
    m_notice(unum,target,getlang(2149,gu(unum,1)));
    return;
  }
  for(i=0;i<strlen(cargs[1]);i++) {
    if (cargs[1][i]=='@') {
      key=1; break;
    }
  }
  if (!key) {
    m_notice(unum,target,getlang(2150,gu(unum,1)));
    return;
  }
  resetchar(tmpacc);
  strcp(tmpacc,getauth(unum));
  strtolower(tmpacc);
  res=pg_query("SELECT passwd FROM users WHERE lower(account)='%s';",tmpacc);
  if (res==NULL) {
    m_notice(unum,target,getlang(8217,gu(unum,1)));
    PQclear(res);
    return;
  }
  if (PQntuples(res)<1) {
    m_notice(unum,target,getlang(2151,gu(unum,1)),mconfig_get("helpchan","#gamerirc"));
    PQclear(res);
    return;
  }
  if (strcmp(PQgetvalue(res,0,0),cargs[0])) {
    m_notice(unum,target,getlang(2152,gu(unum,1)));
    PQclear(res);
    return;
  }
  /* generate verification key */
  srand(time(NULL));
  key=rand()%10000000+99999999;
  pg_query("INSERT INTO emailverify (email,account,ctime,verifykey) VALUES ('%s','%s','%ld','%d');",cargs[1],getauth(unum),time(NULL),key);
  sprintf(mailsub,"[%s]: %s",mconfig_get("network","GamerIRC"),getlang(2153,gu(unum,1)));
  mailsend(cargs[1],mailsub,getlang(2154,gu(unum,1)),getauth(unum),mconfig_get("verifyurl","http://my.gamerirc.org/verify"),key,mconfig_get("network","GamerIRC"));
  m_notice(unum,target,getlang(2155,gu(unum,1)));
  PQclear(res);
}

void load_cservice_cmd_email(void) {
  chl_add(command_module,command_name,cservice_cmd_email,command_oper,command_type,command_auth,command_desc);
}
