/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : help.c                                                      :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "clients.h"
#include "channels.h"
#include "dynhdl.h"

#define command_module "cservice"
#define command_name   "help"
#define command_desc   2156
#define command_oper   0
#define command_type   2
#define command_auth   0

void cservice_pub_help(char *arg, char *unum, char *target) {
  chl *a; int gauth; char *sm;
  sm=getmodsnum(command_module);
  m_notice(unum,sm,getlang(8208,gu(unum,1)));
  m_notice(unum,sm,"---");
  gauth=isauthed(unum);
  for(a=cmd_list;a!=NULL;a=a->next) {
    if ((!strcmp(a->module,command_module)) && a->active && a->type==2) {
      if (a->oper || (a->auth && !gauth)) continue;
      m_notice(unum,sm,"\02%s\02 %s",a->command,getlang(a->desc,gu(unum,1)));
    }
  }
  if (isoper(unum)) {
    for(a=cmd_list;a!=NULL;a=a->next) {
      if ((!strcmp(a->module,command_module)) && a->active && a->type==2) {
        if (a->oper && isoper(unum) && (a->auth && gauth)) {
          m_notice(unum,sm,"\02%s\02 %s (oper)",a->command,getlang(a->desc,gu(unum,1)));
        }
      }
    }
  }
  m_notice(unum,sm,"---");
  m_notice(unum,sm,"End of list.");
}

void load_cservice_pub_help(void) {
  chl_add(command_module,command_name,cservice_pub_help,command_oper,command_type,command_auth,command_desc);
}
