/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : op.c (pub)                                                  :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "strfunc.h"
#include "modbas.h"
#include "clients.h"
#include "channels.h"
#include "dynhdl.h"

#define command_module "cservice"
#define command_name   "op"
#define command_desc   2419
#define command_oper   0
#define command_type   2
#define command_auth   1

int opnickbymask(char *mask, char *chan, char *unum, char *target) {
  cusers *a; users *b; char tmpulist[512],tmpmarg[512],newmask[512]; int a1=0,a2=0;
  resetchar(tmpulist);
  resetchar(tmpmarg);
  resetchar(newmask);
  for(a=cuser_list;a!=NULL;a=a->next) {
    if (a->name==NULL || a->unum==NULL) continue;
    if (!strcasecmp(a->name,chan)) {
      if ((b=uptr(a->unum))==NULL) {
        printf("no-ptr\n");
        continue;
      }
      sprintf(newmask,"%s!%s@%s",b->nick,b->ident,b->host);
      if (strmatch(mask,newmask)) {
        strcat(tmpulist,a->unum);
        strcat(tmpulist," ");
        strcat(tmpmarg,"o");
        if (IsOpped(a->flags)) continue;
        SetOpped(a->flags);
        a1++; a2++;
        if (a1>=6) {
          send2up("%s M %s +%s %s",getmodsnum(command_module),chan,tmpmarg,tmpulist);
          resetchar(tmpulist);
          resetchar(tmpmarg);
          a1=0;
        }
      }
    }
  }
  if (a1>0) {
    send2up("%s M %s +%s %s",getmodsnum(command_module),chan,tmpmarg,tmpulist);
    resetchar(tmpulist);
    resetchar(tmpmarg);
    a1=0;
  }
  return a2;
}

void cservice_pub_op(char *arg, char *unum, char *target) {
  strarray(arg); char masktoop[512]; int i,j; char *sender;
  sender=getmodsnum(command_module);
  if (cargc==0) {
    sprintf(masktoop,"%s!*@*",num2nick(unum));
    i=opnickbymask(masktoop,target,unum,target);
    m_notice(unum,sender,"Chan-Op: \02%d\02 user%s opped.",i,(i==1) ? "" : "s");
    return;
  }
  if (!hascl(target,unum) && !isoper(unum)) {
    m_notice(unum,sender,"You either have no access rights on %s or you are banned/denied.",cargs[0]);
    return;
  }
  if (!cl_master(target,unum) && !cl_owner(target,unum) && !isoper(unum)) {
    m_notice(unum,sender,"You have not enough right to op users. You need the master/owner flag.");
    return;
  }
  resetchar(masktoop);
  if (chrstr('@',cargs[0])) {
    // mask opping
    strncpy(masktoop,cargs[0],strlen(cargs[1]));
    masktoop[strlen(cargs[0])]=0x00;
    i=opnickbymask(masktoop,target,unum,target);
  } else {
    // nick opping
    for(j=0;j<cargc;j++) {
      if (nick2num(cargs[j])==NULL) {
        m_notice(unum,sender,"Skipping op for '%s': User is not online.",cargs[j]);
        return;
      }
      sprintf(masktoop,"%s!*@*",cargs[j]);
      i=opnickbymask(masktoop,target,unum,target);
    }
  }
  m_notice(unum,sender,"%s-Op: \02%d\02 user%s opped.",(chrstr('@',cargs[0])) ? "Mask" : "Nick",i,(i==1) ? "" : "s");
}

void load_cservice_pub_op(void) {
  chl_add(command_module,command_name,cservice_pub_op,command_oper,command_type,command_auth,command_desc);
}
