/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : voice.c                                                     :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"

#define command_module "cservice"
#define command_name   "voice"
#define command_desc   2276
#define command_oper   0
#define command_type   1
#define command_auth   1

int voicenickbymask(char *mask, char *chan, char *unum, char *target) {
  cusers *a; users *b; char tmpulist[512],tmpmarg[512],newmask[512]; int a1=0,a2=0;
  resetchar(tmpulist);
  resetchar(tmpmarg);
  resetchar(newmask);
  for(a=cuser_list;a!=NULL;a=a->next) {
    assert(a->unum);
    if (!strcasecmp(a->name,chan)) {
      if ((b=uptr(a->unum))==NULL) {
        continue;
      }
      if (IsVoiced(a->flags)) continue;
      sprintf(newmask,"%s!%s@%s",b->nick,b->ident,b->host);
      if (strmatch(mask,newmask)) {
        strcat(tmpulist,a->unum);
        strcat(tmpulist," ");
        strcat(tmpmarg,"v");
        SetVoice(a->flags);
        a1++; a2++;
        if (a1>=6) {
          send2up("%s M %s +%s %s",getmodsnum(command_module),chan,tmpmarg,tmpulist);
          resetchar(tmpulist);
          resetchar(tmpmarg);
          a1=0;
        }
      }
    }
  }
  if (a1>0) {
    send2up("%s M %s +%s %s",getmodsnum(command_module),chan,tmpmarg,tmpulist);
    resetchar(tmpulist);
    resetchar(tmpmarg);
    a1=0;
  }
  return a2;
}

void cservice_cmd_voice(char *arg, char *unum, char *target) {
  strarray(arg); char masktovc[512]; int i,j;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2277,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2168,gu(unum,1)));
    return;
  } else if (cargc<2) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findchannel(cargs[0])) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  if (!hascl(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2042,gu(unum,1)),cargs[0]);
    return;
  }
  if (!cl_master(cargs[0],unum) && !cl_owner(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2278,gu(unum,1)));
    return;
  }
  resetchar(masktovc);
  if (chrstr('@',cargs[1])) {
    // mask opping
    strncpy(masktovc,cargs[1],strlen(cargs[1]));
    masktovc[strlen(cargs[1])]=0x00;
    i=voicenickbymask(masktovc,cargs[0],unum,target);
  } else {
    // nick opping
    for(j=1;j<cargc;j++) {
      if (nick2num(cargs[j])==NULL) {
        m_notice(unum,target,getlang(2279,gu(unum,1)),cargs[1]);
        return;
      }
      sprintf(masktovc,"%s!*@*",cargs[j]);
      i=voicenickbymask(masktovc,cargs[0],unum,target);
    }
  }
  m_notice(unum,target,getlang(2280,gu(unum,1)),(chrstr('@',cargs[1])) ? "Mask" : "Nick",i,(i==1) ? "" : "s");
}

void load_cservice_cmd_voice(void) {
  chl_add(command_module,command_name,cservice_cmd_voice,command_oper,command_type,command_auth,command_desc);
}
